import { AType, Materialized } from '@morphic-ts/summoners';
import { TaggedUnionProg, UnionTypes } from '@morphic-ts/summoners/lib/tagged-union';
import { InhabitedTypes } from '@morphic-ts/summoners/lib/utils';
export declare type AnyH = InhabitedTypes<any, any, any> & {
    readonly tag: string;
};
export declare type TagsOf<X extends InhabitedTypes<any, any, any> & {
    readonly tag: string;
}> = AType<X>[X['tag']];
export declare type Narrow<AU, U extends {
    readonly tag: string;
}, Tag> = Extract<AU, {
    readonly [GG in U['tag']]: Tag;
}>;
export declare type TypeOf<G extends {
    readonly Union: AnyH;
}, UnionMorph extends G['Union'] = G['Union'], UnionType extends AType<UnionMorph> = AType<UnionMorph>> = {
    readonly [Tag in TagsOf<UnionMorph>]: Narrow<UnionType, UnionMorph, Tag>;
} & {
    readonly Union: UnionType;
};
export declare const makeUnion: <ProgURI extends "Dummy", InterpURI extends "_", R>(summ: <E, A>(F: TaggedUnionProg<R, E, A, ProgURI>) => Materialized<R, E, A, ProgURI, InterpURI>) => <Tag extends string>(tag: Tag) => <Types extends UnionTypes<Types, Tag, ProgURI, InterpURI, R>>(types: Types) => Types & {
    Union: import("@morphic-ts/summoners/lib/tagged-union").MorphADT<{ [k in keyof Types]: Types[k] extends InhabitedTypes<any, infer E_1, infer A_1> ? [E_1, A_1] : never; }, Tag, ProgURI, InterpURI, R>;
};
//# sourceMappingURL=index.d.ts.map